package ovt;

import java.beans.*;

public class OVTCoreBeanInfo extends SimpleBeanInfo {

  // Property identifiers //GEN-FIRST:Properties
  private static final int PROPERTY_frames = 12;
  private static final int PROPERTY_outputLabel = 4;
  private static final int PROPERTY_magnetosphere = 5;
  private static final int PROPERTY_sats = 13;
  private static final int PROPERTY_earth = 6;
  private static final int PROPERTY_fieldlineMappers = 14;
  private static final int PROPERTY_bowShock = 3;
  private static final int PROPERTY_coordinateSystem = 2;
  private static final int PROPERTY_electPot = 7;
  private static final int PROPERTY_axes = 8;
  private static final int PROPERTY_magProps = 1;
  private static final int PROPERTY_backgroundColor = 9;
  private static final int PROPERTY_magnetopause = 10;
  private static final int PROPERTY_timeSettings = 0;
  private static final int PROPERTY_camera = 16;
  private static final int PROPERTY_sunLight = 11;
  private static final int PROPERTY_groundStations = 15;

  // Property array 
  private static PropertyDescriptor[] properties = new PropertyDescriptor[17];

  static {
    try {
      properties[PROPERTY_frames] = new PropertyDescriptor ( "frames", OVTCore.class, "getFrames", null );
      properties[PROPERTY_outputLabel] = new PropertyDescriptor ( "outputLabel", OVTCore.class, "getOutputLabel", null );
      properties[PROPERTY_magnetosphere] = new PropertyDescriptor ( "magnetosphere", OVTCore.class, "getMagnetosphere", null );
      properties[PROPERTY_sats] = new PropertyDescriptor ( "sats", OVTCore.class, "getSats", null );
      properties[PROPERTY_earth] = new PropertyDescriptor ( "earth", OVTCore.class, "getEarth", null );
      properties[PROPERTY_fieldlineMappers] = new PropertyDescriptor ( "fieldlineMappers", OVTCore.class, "getFieldlineMappers", "setFieldlineMappers" );
      properties[PROPERTY_bowShock] = new PropertyDescriptor ( "bowShock", OVTCore.class, "getBowShock", null );
      properties[PROPERTY_coordinateSystem] = new PropertyDescriptor ( "coordinateSystem", OVTCore.class, "getCoordinateSystem", null );
      properties[PROPERTY_electPot] = new PropertyDescriptor ( "electPot", OVTCore.class, "getElectPot", null );
      properties[PROPERTY_axes] = new PropertyDescriptor ( "axes", OVTCore.class, "getAxes", null );
      properties[PROPERTY_magProps] = new PropertyDescriptor ( "magProps", OVTCore.class, "getMagProps", null );
      properties[PROPERTY_backgroundColor] = new PropertyDescriptor ( "backgroundColor", OVTCore.class, "getBackgroundColor", "setBackgroundColor" );
      properties[PROPERTY_magnetopause] = new PropertyDescriptor ( "magnetopause", OVTCore.class, "getMagnetopause", null );
      properties[PROPERTY_timeSettings] = new PropertyDescriptor ( "timeSettings", OVTCore.class, "getTimeSettings", null );
      properties[PROPERTY_camera] = new PropertyDescriptor ( "camera", OVTCore.class, "getCamera", null );
      properties[PROPERTY_sunLight] = new PropertyDescriptor ( "sunLight", OVTCore.class, "getSunLight", null );
      properties[PROPERTY_groundStations] = new PropertyDescriptor ( "groundBasedStations", OVTCore.class, "getGroundBasedStations", null );
    }
    catch( IntrospectionException e) {}//GEN-HEADEREND:Properties

    // Here you can add code for customizing the properties array.

}//GEN-LAST:Properties

  // EventSet identifiers//GEN-FIRST:Events

  // EventSet array
  private static EventSetDescriptor[] eventSets = new EventSetDescriptor[0];
//GEN-HEADEREND:Events

    // Here you can add code for customizing the event sets array.

  //GEN-LAST:Events
  private static final int METHOD_fireChildrenChanged28 = 0;
  // Method identifiers //GEN-FIRST:Methods
  private static final int METHOD_fireChildrenChanged0 = 0;

  // Method array 
  private static MethodDescriptor[] methods = new MethodDescriptor[1];

  static {
    try {
      methods[METHOD_fireChildrenChanged28] = new MethodDescriptor ( Class.forName("ovt.OVTCore").getMethod("fireChildrenChanged", new Class[] {}));
      methods[METHOD_fireChildrenChanged28].setDisplayName ( "" );
    }
    catch( Exception e) {}//GEN-HEADEREND:Methods

    // Here you can add code for customizing the methods array.
    
}//GEN-LAST:Methods

    private static java.awt.Image iconColor16 = null; //GEN-BEGIN:IconsDef
    private static java.awt.Image iconColor32 = null;
    private static java.awt.Image iconMono16 = null;
    private static java.awt.Image iconMono32 = null; //GEN-END:IconsDef
  private static String iconNameC16 = null;//GEN-BEGIN:Icons
  private static String iconNameC32 = null;
  private static String iconNameM16 = null;
  private static String iconNameM32 = null;//GEN-END:Icons

  private static int defaultPropertyIndex = -1;//GEN-BEGIN:Idx
  private static int defaultEventIndex = -1;//GEN-END:Idx


    /**
     * Gets the bean's <code>PropertyDescriptor</code>s.
     * 
     * @return An array of PropertyDescriptors describing the editable
     * properties supported by this bean.  May return null if the
     * information should be obtained by automatic analysis.
     * <p>
     * If a property is indexed, then its entry in the result array will
     * belong to the IndexedPropertyDescriptor subclass of PropertyDescriptor.
     * A client of getPropertyDescriptors can use "instanceof" to check
     * if a given PropertyDescriptor is an IndexedPropertyDescriptor.
     */
    public PropertyDescriptor[] getPropertyDescriptors() {
        return properties;
    }

    /**
     * Gets the bean's <code>EventSetDescriptor</code>s.
     * 
     * @return  An array of EventSetDescriptors describing the kinds of 
     * events fired by this bean.  May return null if the information
     * should be obtained by automatic analysis.
     */
    public EventSetDescriptor[] getEventSetDescriptors() {
        return eventSets;
    }

    /**
     * Gets the bean's <code>MethodDescriptor</code>s.
     * 
     * @return  An array of MethodDescriptors describing the methods 
     * implemented by this bean.  May return null if the information
     * should be obtained by automatic analysis.
     */
    public MethodDescriptor[] getMethodDescriptors() {
        return methods;
    }

    /**
     * A bean may have a "default" property that is the property that will
     * mostly commonly be initially chosen for update by human's who are 
     * customizing the bean.
     * @return  Index of default property in the PropertyDescriptor array
     * 		returned by getPropertyDescriptors.
     * <P>	Returns -1 if there is no default property.
     */
    public int getDefaultPropertyIndex() {
        return defaultPropertyIndex;
    }

    /**
     * A bean may have a "default" event that is the event that will
     * mostly commonly be used by human's when using the bean. 
     * @return Index of default event in the EventSetDescriptor array
     *		returned by getEventSetDescriptors.
     * <P>	Returns -1 if there is no default event.
     */
    public int getDefaultEventIndex() {
        return defaultPropertyIndex;
    }

    /**
     * This method returns an image object that can be used to
     * represent the bean in toolboxes, toolbars, etc.   Icon images
     * will typically be GIFs, but may in future include other formats.
     * <p>
     * Beans aren't required to provide icons and may return null from
     * this method.
     * <p>
     * There are four possible flavors of icons (16x16 color,
     * 32x32 color, 16x16 mono, 32x32 mono).  If a bean choses to only
     * support a single icon we recommend supporting 16x16 color.
     * <p>
     * We recommend that icons have a "transparent" background
     * so they can be rendered onto an existing background.
     *
     * @param  iconKind  The kind of icon requested.  This should be
     *    one of the constant values ICON_COLOR_16x16, ICON_COLOR_32x32, 
     *    ICON_MONO_16x16, or ICON_MONO_32x32.
     * @return  An image object representing the requested icon.  May
     *    return null if no suitable icon is available.
     */
    public java.awt.Image getIcon(int iconKind) {
        switch ( iconKind ) {
        case ICON_COLOR_16x16:
            if ( iconNameC16 == null )
                return null;
            else {
                if( iconColor16 == null )
                    iconColor16 = loadImage( iconNameC16 );
                return iconColor16;
            }
        case ICON_COLOR_32x32:
            if ( iconNameC32 == null )
                return null;
            else {
                if( iconColor32 == null )
                    iconColor32 = loadImage( iconNameC32 );
                return iconColor32;
            }
        case ICON_MONO_16x16:
            if ( iconNameM16 == null )
                return null;
            else {
                if( iconMono16 == null )
                    iconMono16 = loadImage( iconNameM16 );
                return iconMono16;
            }
        case ICON_MONO_32x32:
            if ( iconNameM32 == null )
                return null;
            else {
                if( iconNameM32 == null )
                    iconMono32 = loadImage( iconNameM32 );
                return iconMono32;
            }
        }
        return null;
    }

}

