/*=========================================================================

Program:   Orbit Visualization Tool
Source:    $Source: /stor/devel/ovt2g/ovt/datatype/FieldlineGBStartPoint.java,v $
Date:      $Date: 2002/06/30 17:02:37 $
Version:   $Revision: 2.1 $


Copyright (c) 2000-2002 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev,
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * FieldlineGBStartPoint.java
 *
 * Created on June 25, 2002, 2:35 PM
 */

package ovt.datatype;

/**
 * Data type for {@link ovt.object.FieldlineMapper ovt.object.FieldlineMapper}.
 * @author  ko
 * @version 
 * @see ovt.object.FieldlineMapper#getStartPoints()
 */
public class FieldlineGBStartPoint extends PolarCoord {

    private String id="no id";
    
    /** Creates new FieldlineGBStartPoint */
    public FieldlineGBStartPoint() {
    }
    
    /** Creates new FieldlineGBStartPoint */
    public FieldlineGBStartPoint(double lat, double lon) {
        super(lat, lon);
    }
    
    /** Creates new FieldlineGBStartPoint */
    public FieldlineGBStartPoint(double lat, double lon, String id) {
        super(lat, lon);
        this.id = id;
    }
    
    public String getID() {
        return id;
    }
    
    /** Sets the ID of the point (for example : the name of the radar) */
    public void setID(String id) {
        this.id = id;
    }

}
