/*=========================================================================

Program:   Orbit Visualization Tool
Source:    $Source: /stor/devel/ovt2g/ovt/gui/FilePanel.java,v $
Date:      $Date: 2002/06/30 17:04:56 $
Version:   $Revision: 2.1 $


Copyright (c) 2000-2002 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev,
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * FilePanel.java
 *
 * Created on June 29, 2002, 7:27 PM
 */

package ovt.gui;

import java.beans.*;

import java.io.*;
import java.util.*;
import java.text.DecimalFormat;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

/**
 *
 * @author  ko
 * @version 
 */
public class FilePanel extends JPanel {

JTextField fileTF;

public FilePanel() {
    setLayout(new BoxLayout (this, BoxLayout.X_AXIS));
    
    fileTF = new JTextField("", 20);
    add(fileTF);

    JButton button = new JButton("Browse...");
    button.setMaximumSize(button.getMinimumSize());
    button.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent evt) {
            chooseFile();
        }
    });
    add(button);

}

protected JTextField getTextField() {
    return fileTF;
}

public File getFile() {
    return new File(fileTF.getText());
}

public void setFile(File file) {
    fileTF.setText(file.getAbsolutePath());
    firePropertyChange("file", null, null);
}

private void chooseFile() {

    //String startDir = getFile();
    JFileChooser chooser = new JFileChooser(getFile());

    int returnVal = chooser.showDialog(this, "OK");
    if (returnVal == JFileChooser.APPROVE_OPTION) {
        File tmpFile = chooser.getSelectedFile();
        if ( tmpFile.exists() ) {
            if ( tmpFile.isDirectory() ) {
                JOptionPane.showMessageDialog(this,
                "File is a directory.",
                "File error",
                JOptionPane.ERROR_MESSAGE);
                return;
            }
            if ( !tmpFile.canRead() ) {
                JOptionPane.showMessageDialog(this,
                "File is not readable.",
                "File error",
                JOptionPane.ERROR_MESSAGE);
                return;
            }
        }
        setFile(tmpFile);
        fileTF.setMaximumSize(fileTF.getSize());
        //System.out.println("Set size: " + fileTF.getSize());
        fileTF.setPreferredSize(fileTF.getSize());
        // fileTF.setText(file.toString()); - in setFIle
    }
}

}
